stages:
  - build
  - test
  - qa
  - release
  - deploy

empaquetar:
  stage: build
  tags:
    - mi-runner
  script:
    - mvn package -DskipTests=true
  artifacts:
    paths:
      - target/
pruebas-unitarias:
  stage: build
  tags:
    - mi-runner
  script:
    - mysql -u root < db/baloncesto.sql
    - export DATABASE_HOST="jdbc:mysql://localhost"
    - export DATABASE_PORT="3306"
    - export DATABASE_NAME="baloncesto"
    - export DATABASE_USER="usuario"
    - export DATABASE_PASS="clave"
    - sh /usr/local/tomcat/bin/catalina.sh stop
    - sh /usr/local/tomcat/bin/catalina.sh start
    - mvn test
pruebas-funcionales:
 stage: test
 tags:
  - mi-runner
 dependencies:
  - empaquetar
 script:
  - cp -r target/Baloncesto /usr/local/tomcat/webapps
  - mysql -u root < db/baloncesto.sql
  - export DATABASE_HOST="jdbc:mysql://localhost"
  - export DATABASE_PORT="3306"
  - export DATABASE_NAME="baloncesto"
  - export DATABASE_USER="usuario"
  - export DATABASE_PASS="clave"
  - sh /usr/local/tomcat/bin/catalina.sh stop
  - sh /usr/local/tomcat/bin/catalina.sh start
  - mvn failsafe:integration-test failsafe:verify
calidad-codigo:
 stage: qa
 tags:
  - mi-runner
 dependencies:
  - empaquetar
 script:
  - mvn sonar:sonar -Dsonar.host.url=http://sonarqube:9000 -Dsonar.qualitygate.wait=true -Dsonar.login=admin -Dsonar.password=admin1
 allow_failure: true
despliegue-pre:
 stage: release
 image: docker
 services:
  - docker:dind
 dependencies:
  - empaquetar
 script:
  - docker login registry.gitlab.com -u azahara.ballester -p $CLAVE
  - docker build -t registry.gitlab.com/azahara.ballester/baloncesto/pre/baloncesto-pre .
  - docker push registry.gitlab.com/azahara.ballester/baloncesto/pre/baloncesto-pre
 when: manual
 only:
  - master
despliegue:
 stage: deploy
 image: docker
 services:
  - docker:dind
 dependencies:
  - empaquetar
 script:
  - docker login registry.gitlab.com -u azahara.ballester -p $CLAVE
  - docker build -t registry.gitlab.com/azahara.ballester/baloncesto .
  - docker push registry.gitlab.com/azahara.ballester/baloncesto
 when: manual
 only:
  - master